class RectButton {
  float x;
  float y;
  float w;
  float h;
  Boolean status;
  color pressedColor;
  color hoverColor;
  color onColor;
  color offColor;

  RectButton(float _x, 
    float _y, 
    float _w, 
    float _h, 
    Boolean _status, 
    color _pressedColor, 
    color _hoverColor, 
    color _onColor, 
    color _offColor) 
  {
    x = _x;
    y = _y;
    w = _w;
    h = _h;
    status = _status;
    pressedColor = _pressedColor;
    hoverColor = _hoverColor;
    onColor = _onColor;
    offColor = _offColor;
  }

  void draw() {
    noStroke();
    if (this.mouseOnButton()) {
      if (mousePressed) fill(pressedColor);
      else fill(hoverColor);
    } else {
      if (status) fill (onColor);
      else fill(offColor);
    }
    rectMode(CENTER);
    rect(x, y, w, h);
  }

  boolean mouseOnButton() {
    return (between(mouseX, x-w/2, x+w/2) && between(mouseY, y-h/2, y+h/2));
  }

  void setStatus(boolean _status) {
    status = _status;
  }
  void changeStatus() {
    status = !status;
  }
}

boolean between(float a, float b, float c ) {
  return ((a>=b)&&(a<=c)) || ((a>=c)&&(a<=b));
}