void mouseInteraction() {

  // Judgement for which sin the mouse is hovering on
  //
  PVector center = new PVector(width*7/8, height*13/16);
  PVector mouse = new PVector(mouseX, mouseY);
  PVector mouseToCenterDistance = mouse.sub(center);
  float angle = PVector.angleBetween(mouseToCenterDistance, new PVector(1.f, 0.f));
  for (int i= 0; i<7; i++) {
    mouseOnSins[i] = false;
  }
  if (mouseToCenterDistance.mag() < overallRadius/3) {
    interactWithSin = true;
    if (angle < 2*PI/7) {
      if (mouseY > center.y) mouseOnSins[0] = true;
      else mouseOnSins[6] = true;
    } else if (angle < 4*PI/7) {
      if (mouseY > center.y) mouseOnSins[1] = true;
      else mouseOnSins[5] = true;
    } else if (angle < 6*PI/7) {
      if (mouseY > center.y) mouseOnSins[2] = true;
      else mouseOnSins[4] = true;
    } else mouseOnSins[3] = true;
    //println(degrees(angle));
  } else if (interactWithSin) {
    interactWithSin = false;
  }

  // Judgement for wheter user is interacting with the 4 buttons
  //
  interactWithButtons = false;
  for (int i = 0; i< 4; i++) {
    if (rectButtons[i].mouseOnButton()) {
      interactWithButtons = true;
    }
  }
}

void mousePressed() {
  // ItemType interaction
  //
  if (mouseOnBook) showBook = !showBook;
  if (mouseOnAudio) showAudio = !showAudio;
  if (mouseOnVideo) showVideo = !showVideo;

  // Show other years' items or just the present years'
  //
  if (mouseOnPresentYear) showOtherYear = !showOtherYear;

  // Uptriangle and downtriangle interaction
  //
  if (mouseOnUpTriangle) {
    presentYear ++;
    interpolator[0].target(presentYear);
  }
  if (mouseOnDownTriangle) {
    presentYear --;
    interpolator[0].target(presentYear);
  }

  // seven short lines interaction for choosing the sin user want to see
  //
  for (int i= 0; i<7; i++) {
    if (mouseOnSins[i]) {
      if (showTheSin[i] == true && showTheSin[(i+1)%7]== false) {
        for (int j= 0; j<7; j++) {
          showTheSin[j] = true;
        }
      } else {
        for (int j= 0; j<7; j++) {
          if (j != i) showTheSin[j] = false;
          else showTheSin[j] = true;
        }
      }
    }
  }

  // Buttons' interaction
  //
  for (int i = 0; i <4; i++) {
    if (rectButtons[i].mouseOnButton()) {
      switch (i) {
      case 0 : 
        viewMode++; 
        viewMode = viewMode % 3+1;
        switch (viewMode) {
        case 1: 
          cam.setDistance(2000);
          setRotationInterpolator(0, 0, 0);
          break;
        case 2: 
          setRotationInterpolator(0, -PI/2, 0);
          rotateFree = false;
          break;
        case 3: 
          viewMode = 3;
          setRotationInterpolator(-PI/2, -PI/2, 0);
          rotateFree = false;
        }
        break;
      case 1 : 
        autoRotate = !autoRotate; 
        break;
      case 2 :
        blackOrWhite = !blackOrWhite;
        if (blackOrWhite) {
          colors[9] = #FFFFFF;
          colors[8] = #101010;
        } else {
          colors[8] = #FFFFFF;
          colors[9] = #000000;
        }
        controllerSetup();
        break;
      case 3 : 
        showGUI = !showGUI; 
        break;
      }
    }
  }
}

void keyPressed() {
  if (key == 'S' || key == 's') {
    saveFrame("######.jpg");
  }
  if (key == '=' || key =='+') {
    presentYear++;
    interpolator[0].target(presentYear);
  }
  if (key == '-' || key =='_') {
    presentYear--;
    interpolator[0].target(presentYear);
  }
  if (key == 'F' || key =='f') {
    rotateFree = !rotateFree;
  }
  if (key == 'T' || key == 't') {
    autoRotate = !autoRotate;
  }
  if (key == 'B' || key =='b') {
    showBook = !showBook;
  }
  if (key == 'V' || key =='v') {
    showVideo = !showVideo;
  }
  if (key == 'A' || key =='a') {
    showAudio = !showAudio;
  }
  if (key == 'Y' || key =='y') {
    showOtherYear = !showOtherYear;
  }
  if (key == 'H' || key == 'h') {
    showGUI = !showGUI;
  }
  if (key == 'C' || key == 'c') {
    for (int i =0; i<rowNums; i++) {
      l.getItem(i).put("state", false);
    }
  }
  if (key == 'P' || key == 'p') {
    onlyStillFrame = !onlyStillFrame;
  }
  if (key == '1') {
    viewMode = 1;
    cam.setDistance(1600);
    setRotationInterpolator(0, 0, 0);
  }
  if (key == '2') {
    viewMode = 2;
    setRotationInterpolator(0, -PI/2, 0);
    rotateFree = false;
  }
  if (key == '3') {
    viewMode = 3;
    setRotationInterpolator(-PI/2, -PI/2, 0);
    rotateFree = false;
  }
}

void setRotationInterpolator(float rx, float ry, float rz) {
  interpolator[1].set(cam.getRotations()[0]);
  interpolator[2].set(cam.getRotations()[1]);
  interpolator[3].set(cam.getRotations()[2]);
  interpolator[1].target(rx);
  interpolator[2].target(ry);
  interpolator[3].target(rz);
}