void controllerSetup() {
  cp5 = new ControlP5(this);

  ControlFont labelFont = new ControlFont(fonts[0], 16);
  ControlFont valueFont = new ControlFont(fonts[1], 12);

  l = cp5.addListBox("myList")
    .setPosition(width/16, height/2 + 150)
    .setSize(width/4-width/16, 3*height/8 - 150)
    .setItemHeight(15)
    .setBarHeight(15)
    .setColorBackground(colors[8])
    .setColorActive(colors[9])
    .setColorForeground(0xFFEB6002)
    ;
  l.getCaptionLabel().toUpperCase(true);
  l.getCaptionLabel().set("Item Title");
  l.getCaptionLabel().setColor(colors[9]);
  l.getCaptionLabel().setFont(labelFont);
  l.getCaptionLabel().getStyle().marginTop= 5;
  l.getCaptionLabel().getStyle().marginLeft= -5;
  l.getValueLabel().setColor(colors[9]);
  l.getValueLabel().setFont(valueFont);
  l.getValueLabel().getStyle().marginTop= 5;
  l.getValueLabel().getStyle().marginLeft= -5;
  for (int i=0; i<rowNums; i++) {
    String title = nf(i, 3)+" "+ dataTable.getRow(i).getString(0);
    int maxLength = int((width/4-width/16)/7);
    if (title.length()>maxLength) title= title.substring(0, maxLength);
    l.addItem(title, i);
    CColor c = new CColor();
    //c.setBackground(0x14141400);
    c.setBackground(colors[8]);
    //println(c);
    l.getItem(title).put("color", c);
    //println(l.getItem(title));
  }
  cp5.setAutoDraw(false);
  
  
    
  // Initialize four buttons
  //
  float buttonSpacing = width/16;
  float buttonwidth = width/16*7/8;
  float buttonHeight = 5;
  float pressedColor = 90;
  float hoverColor = 128;
  float onColor = 180;
  float offColor = 40;

  rectButtons = new RectButton[4];
  rectButtons[0] = new RectButton(width/2-1.5*buttonSpacing, height*15/16-buttonHeight, buttonwidth, buttonHeight, true, color(pressedColor), color(hoverColor), color(onColor), color(offColor));
  rectButtons[1] = new RectButton(width/2-0.5*buttonSpacing, height*15/16-buttonHeight, buttonwidth, buttonHeight, autoRotate, color(pressedColor), color(hoverColor), color(onColor), color(offColor));
  rectButtons[2] = new RectButton(width/2+0.5*buttonSpacing, height*15/16-buttonHeight, buttonwidth, buttonHeight, blackOrWhite, color(pressedColor), color(hoverColor), color(onColor), color(offColor));
  rectButtons[3] = new RectButton(width/2+1.5*buttonSpacing, height*15/16-buttonHeight, buttonwidth, buttonHeight, showGUI, color(pressedColor), color(hoverColor), color(onColor), color(offColor));
}



void gui() {

  cp5.draw();

  float horizonalLocation = width/16;
  float verticalLocation = height/2;
  float dist = 25;

  fill(128, 30);
  noStroke();
  rectMode(CORNER);
  //rect(width/32, height/16, width/4, height/8);
  rect(width/32, height/2-height/16, width/4, height/2);

  boolean isMouseInX = (mouseX > width/32) && (mouseX<(width/4+width/32));
  boolean isMouseInY = (mouseY > (height/2-height/16)) && (mouseY <(height-height/16));
  boolean isMouseIn = isMouseInX && isMouseInY;

  if (isMouseIn||interactWithSin||interactWithButtons) cam.setActive(false);
  else cam.setActive(true);

  // -------------------------------------------------------------- //
  // Big Title
  //
  fill(colors[9], 200);
  textFont(fonts[1], 16);
  textAlign(LEFT, BOTTOM);
  text("The 7 prevalently checked out items of", horizonalLocation, height/8-20);
  textFont(fonts[0], 48);
  textAlign(LEFT, TOP);
  text("7 DEADLY SINS", horizonalLocation, height/8);

  // -------------------------------------------------------------- //
  // Present year label
  // (1). judgement
  //
  mouseOnPresentYear = between(mouseY, verticalLocation, verticalLocation+40) && 
    between(mouseX, horizonalLocation, horizonalLocation + textWidth(str(presentYear)));

  // (2). draw text
  //
  textAlign(LEFT, TOP);
  if (mouseOnPresentYear) {
    if (presentYear == 1990) {
      if (mousePressed) fill(colors[9], 200);
      else fill(colors[9], 120);
      textFont(fonts[0], 24);
      text("BEFORE ", horizonalLocation, verticalLocation-40);
      textFont(fonts[0], 48);
      text(str(presentYear+1), horizonalLocation, verticalLocation);
    } else if (presentYear > 1990 && presentYear < 2015) {
      if (mousePressed) fill(colors[9], 200);
      else fill(colors[9], 120);
      textFont(fonts[0], 48);
      text(str(presentYear), horizonalLocation, verticalLocation);
    } else {
      if (mousePressed) fill(colors[9], 200);
      else fill(colors[9], 120);
      textFont(fonts[0], 48);
      text(str(presentYear), horizonalLocation, verticalLocation);
    }
  } else {
    if (presentYear == 1990) {
      fill(colors[9], 200);
      textFont(fonts[0], 24);
      text("BEFORE ", horizonalLocation, verticalLocation-40);
      textFont(fonts[0], 48);
      text(str(presentYear+1), horizonalLocation, verticalLocation);
    } else if (presentYear > 1990 && presentYear < 2015) {
      fill(colors[9], 200);
      textFont(fonts[0], 48);
      text(str(presentYear), horizonalLocation, verticalLocation);
    } else {
      fill(colors[9], 40);
      textFont(fonts[0], 48);
      text(str(presentYear), horizonalLocation, verticalLocation);
    }
  }

  // -------------------------------------------------------------- //
  // Up and down Triangles for adjusting present year
  // (1). intitialization
  //
  PVector[] upTrianglePoints = new PVector[3];
  PVector[] downTrianglePoints = new PVector[3];
  upTrianglePoints[0] = new PVector(horizonalLocation + textWidth(str(presentYear)) + 10, verticalLocation-6);
  upTrianglePoints[1] = new PVector(horizonalLocation + textWidth(str(presentYear)) + 5, verticalLocation+10);
  upTrianglePoints[2] = new PVector(horizonalLocation + textWidth(str(presentYear)) + 15, verticalLocation+10); 
  downTrianglePoints[0] = new PVector(horizonalLocation + textWidth(str(presentYear)) + 10, verticalLocation+24+6);
  downTrianglePoints[1] = new PVector(horizonalLocation + textWidth(str(presentYear)) + 5, verticalLocation+24-10);
  downTrianglePoints[2] = new PVector(horizonalLocation + textWidth(str(presentYear)) + 15, verticalLocation+24-10);

  // (2). judgement
  //
  mouseOnUpTriangle = false;
  if (between(mouseY, upTrianglePoints[0].y, upTrianglePoints[1].y)) {
    float heightRatio = (mouseY - upTrianglePoints[0].y) / (upTrianglePoints[1].y-upTrianglePoints[0].y);
    PVector p1 = PVector.lerp(upTrianglePoints[0], upTrianglePoints[1], heightRatio);
    PVector p2 = PVector.lerp(upTrianglePoints[0], upTrianglePoints[2], heightRatio);
    if (between(mouseX, p1.x, p2.x)) {
      mouseOnUpTriangle = true;
    }
  }
  mouseOnDownTriangle = false;
  if (between(mouseY, downTrianglePoints[0].y, downTrianglePoints[1].y)) {
    float heightRatio = (mouseY - downTrianglePoints[0].y) / (downTrianglePoints[1].y-downTrianglePoints[0].y);
    PVector p1 = PVector.lerp(downTrianglePoints[0], downTrianglePoints[1], heightRatio);
    PVector p2 = PVector.lerp(downTrianglePoints[0], downTrianglePoints[2], heightRatio);
    if (between(mouseX, p1.x, p2.x)) {
      mouseOnDownTriangle = true;
    }
  }

  // (3). draw triagnles
  //
  if (mouseOnUpTriangle) {
    if (mousePressed) fill(colors[9], 200);
    else fill(colors[9], 120);
  } else fill(colors[9], 200);
  triangle(upTrianglePoints[0].x, upTrianglePoints[0].y, upTrianglePoints[1].x, upTrianglePoints[1].y, upTrianglePoints[2].x, upTrianglePoints[2].y);
  if (mouseOnDownTriangle) {
    if (mousePressed) fill(colors[9], 200);
    else fill(colors[9], 120);
  } else fill(colors[9], 200);
  triangle(downTrianglePoints[0].x, downTrianglePoints[0].y, downTrianglePoints[1].x, downTrianglePoints[1].y, downTrianglePoints[2].x, downTrianglePoints[2].y);



  // -------------------------------------------------------------- //
  // The three item types
  // 1. judgement
  //
  mouseOnBook = false;
  mouseOnAudio = false;
  mouseOnVideo = false;
  if (between(mouseX, horizonalLocation, (horizonalLocation+textWidth("Video"))) && between(mouseY, (verticalLocation + 50), (verticalLocation + dist*3 + 50))) {
    if (between (mouseY, (verticalLocation + 50), (verticalLocation + 50+dist)))              mouseOnBook = true;
    if (between (mouseY, (verticalLocation + dist + 50), (verticalLocation + dist*2 + 50)))   mouseOnVideo = true;
    if (between (mouseY, (verticalLocation + dist*2 + 50), (verticalLocation + dist*3 + 50))) mouseOnAudio = true;
  }

  // 2. draw text
  //
  textFont(fonts[0], 24);
  if (mouseOnBook) {
    if (mousePressed) fill(colors[9], 200);
    else fill(colors[9], 120);
  } else {
    if (showBook) fill(colors[9], 200);
    else fill(colors[9], 40);
  }
  text("Book", horizonalLocation, verticalLocation + 50);
  if (mouseOnVideo) {
    if (mousePressed) fill(colors[9], 200);
    else fill(colors[9], 120);
  } else {
    if (showVideo) fill(colors[9], 200);
    else fill(colors[9], 40);
  }
  text("Video", horizonalLocation, verticalLocation + dist + 50);
  if (mouseOnAudio) {
    if (mousePressed) fill(colors[9], 200);
    else fill(colors[9], 120);
  } else {
    if (showAudio) fill(colors[9], 200);
    else fill(colors[9], 40);
  }
  text("Audio", horizonalLocation, verticalLocation + dist*2 + 50);


  // -------------------------------------------------------------- //
  // Sevent lines representing seven deadly sins
  // (Mouse location judgement is moved into Interaction.pde)
  // (1). seven lines
  //
  pushMatrix();
  translate(width*7/8, height*13/16);
  beginShape(LINES);
  for (int i = 0; i< 7; i++) {
    PVector p1 = PVector.lerp(Points[i], Points[(i+1)%7], 0.1);
    PVector p2 = PVector.lerp(Points[i], Points[(i+1)%7], 0.9);
    //println(p1);
    strokeWeight(3);
    if (mouseOnSins[i]) {
      if (mousePressed) stroke(colors[i], 255);
      else stroke(colors[i], 100);
    } else {
      if (showTheSin[i]) stroke(colors[i], 255);
      else stroke(colors[i], 20);
    }
    vertex(p1.x/5, p1.y/5, 0);
    vertex(p2.x/5, p2.y/5, 0);
  }
  endShape();

  // (2). seven text labels
  //
  for (int i = 0; i< 7; i++) {
    PVector p3 = PVector.lerp(Points[i], Points[(i+1)%7], 0.5);
    pushMatrix();
    translate(p3.x/5*1.1, p3.y/5*1.1);
    rotate((i+0.5)*2*PI/7+PI/2);
    fill(colors[9], 200);
    textAlign(CENTER, BOTTOM);
    textFont(fonts[0], 12);
    text(sevenDeadlySins[i], 0, 0);
    popMatrix();
  }
  popMatrix();
}


void drawButtons() {
  rectButtons[1].setStatus(autoRotate);
  rectButtons[2].setStatus(blackOrWhite);
  rectButtons[3].setStatus(showGUI);

  rectButtons[0].draw();
  rectButtons[1].draw();
  rectButtons[2].draw();
  rectButtons[3].draw();

  textAlign(CENTER, BOTTOM);
  textFont(fonts[1], 12);
  fill(rectButtons[0].hoverColor);
  text("viewmode", rectButtons[0].x, rectButtons[0].y-10);
  text("auto rotate", rectButtons[1].x, rectButtons[1].y-10);
  text("black/white", rectButtons[2].x, rectButtons[2].y-10);
  text("interface", rectButtons[3].x, rectButtons[3].y-10);
}